#include "include/ti84pluscse.inc"
.org userMem-2
.db $EF, $69

start:
	bcall(_maybe_RunIndicOff)
	bcall(_RclAns)
	bcall(_ConvOP1)
	ld (args), a
	call handleArguments
	ld hl, (fgcolor)
	ld (_window_foreground), hl
	ld hl, (bgcolor)
	ld (_window_background), hl

	call setCPUFast
	call moveBallCenter

	ld hl, IMG0
	ld (paddle1pointsaddr), hl
	ld hl, IMG0
	ld (paddle2pointsaddr), hl

	ld hl, (bgcolor)
	call fillScreen

loop:

	ld hl, (fgcolor)
	call drawPaddle1
	ld hl, (fgcolor)
	call drawPaddle2
	ld hl, (fgcolor)
	call drawDivider

	ld hl, 75
	ld (_window_x1), hl
	ld hl, 15
	ld (_window_y1), hl
	ld hl, 75+10-1
	ld (_window_x2), hl
	ld hl, 15+21-1
	ld (_window_y2), hl
	call setWindow
	ld hl, (paddle1pointsaddr)
	call drawSpriteFGBG

	ld hl, 319-75
	ld (_window_x1), hl
	ld hl, 15
	ld (_window_y1), hl
	ld hl, 319-75+10-1
	ld (_window_x2), hl
	ld hl, 15+21-1
	ld (_window_y2), hl
	call setWindow
	ld hl, (paddle2pointsaddr)
	call drawSpriteFGBG

	call moveBall

	ld a, (cpuon)
	cp 1
	call z, moveCPU
	ld a, (cpuon)
	cp 1
	call z, handleSinglePlayerKeys
	ld a, (cpuon)
	cp 1
	call nz, handleMultiplayerKeys

	;check for clear key
	ld a, %11111111
	out ($01), a
	ld a, %11111101
	out ($01), a
	in a, ($01)
	bit 6, a
	jp nz, loop 

	call setWindowFull
	bcall(_maybe_ClrLCDFull)
	bcall(_DrawStatusBar)

	ret

handleMultiplayerKeys:

	;check for 0 key
	ld a, %11111111
	out ($01), a
	ld a, %11101111
	out ($01), a
	in a, ($01)
	bit 0, a
	call z, moveDown

	;check for 1 key
	ld a, %11111111
	out ($01), a
	ld a, %11101111
	out ($01), a
	in a, ($01)
	bit 1, a
	call z, moveUp

	;not sure why
	;but these lines fix a glitch
	;--------------------------
	ld a, %11111111
	out ($01), a
	ld a, %11111011
	out ($01), a
	in a, ($01)
	bit 0, a
	ld a, %11111111
	out ($01), a
	ld a, %11111011
	out ($01), a
	in a, ($01)
	bit 0, a
	;--------------------------

	;check for - key
	ld a, %11111111
	out ($01), a
	ld a, %11111011
	out ($01), a
	in a, ($01)
	bit 0, a
	call z, moveDown2

	;check for 3 key
	ld a, %11111111
	out ($01), a
	ld a, %11111011
	out ($01), a
	in a, ($01)
	bit 1, a
	call z, moveUp2


	ret

handleSinglePlayerKeys:

	;check for down key
	ld a, %11111111
	out ($01), a
	ld a, %11111110
	out ($01), a
	in a, ($01)
	bit 0, a
	call z, moveDown

	;check for up key
	ld a, %11111111
	out ($01), a
	ld a, %11111110
	out ($01), a
	in a, ($01)
	bit 3, a
	call z, moveUp

	ret



beepNoise1:
	ld a, (audioon)
	cp 1
	ret nz 
	ld hl, 750 
	call getDuration
	call play 
	ret

beepNoise2:
	ld a, (audioon)
	cp 1
	ret nz 
	ld hl, 250 
	call getDuration
	call play 
	ret

beepNoise3:
	ld a, (audioon)
	cp 1
	ret nz 
	ld hl, 1250 
	call getDuration
	call play 
	ret

enableCPU:
	ld a, 5
	ld (paddle2speed), a
	ld a, 1
	ld (cpuon), a
	ret
enableAudio:
	ld a, 1
	ld (audioon), a
	ret
setHard:
	ld a, (cpuon)
	cp 1
	ret nz
	ld a, 10
	ld (paddle2speed), a
	ld a, 1
	ld (hard), a
	ret
setNormal:
	ld a, (cpuon)
	cp 1
	ret nz 
	ld a, 7
	ld (paddle2speed), a
	ld a, 1
	ld (hard), a
	ret
setColor2:
	ld hl, $0000
	ld (fgcolor), hl
	ld hl, $FFFF
	ld (bgcolor), hl
	ret
setColor3:
	ld hl, $367F
	ld (fgcolor), hl
	ld hl, $298C
	ld (bgcolor), hl
	ret
setColor4:
	ld hl, $ADB5
	ld (fgcolor), hl
	ld hl, $02E0
	ld (bgcolor), hl
	ret
setColor5:
	ld hl, $2166
	ld (fgcolor), hl
	ld hl, $9D53
	ld (bgcolor), hl
	ret

handleArguments:
	ld a, (args)
	bit 0, a
	call nz, enableCPU
	ld a, (args)
	bit 1, a
	call nz, enableAudio
	ld a, (args)
	bit 2, a
	call nz, setHard
	ld a, (args)
	bit 3, a
	call nz, setNormal
	ld a, (args)
	bit 4, a
	call nz, setColor2
	ld a, (args)
	bit 5, a
	call nz, setColor3
	ld a, (args)
	bit 6, a
	call nz, setColor4
	ld a, (args)
	bit 7, a
	call nz, setColor5
	ret

args:
	.db 0
cpuon:
	.db 0
audioon:
	.db 0
hard:
	.db 0


#include "include/graphics.inc"
#include "include/paddle.inc"
#include "include/NoteMan/noteman.inc"
#include "include/NoteMan/notes.inc"
#include "images/sprites.asm"
